﻿using System.Collections;
using System.Collections.Generic;
using System;
using UnityEngine;
using UnityEngine.Events;
using Random = UnityEngine.Random;
namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static string ModTag = " [BA]"; //Whilst not required, modded items should contain 'tags' at the end of their names to prevent errors in which two mods have an item of the same name.
        public static List<Sprite> brokenparts = new List<Sprite>();
        public static void Main()
        {
            brokenparts.Add(ModAPI.LoadSprite("sprites/brokenpart.png"));
            brokenparts.Add(ModAPI.LoadSprite("sprites/brokenpart2.png"));
            brokenparts.Add(ModAPI.LoadSprite("sprites/brokenpart3.png"));
            brokenparts.Add(ModAPI.LoadSprite("sprites/brokenpart4.png"));
            ModAPI.OnItemSpawned += (sender, args) =>
            {
                var Instance = args.Instance;
                var person = Instance.GetComponent<PersonBehaviour>();
                if (person && person.Limbs[0].SpeciesIdentity == "Android")
                {
                    person.gameObject.GetOrAddComponent<BetterAndroid>();
                    person.Limbs[0].gameObject.GetOrAddComponent<BetterLimb>().type = 0;
                    person.Limbs[1].gameObject.GetOrAddComponent<BetterLimb>().type = 1;
                    person.Limbs[2].gameObject.GetOrAddComponent<BetterLimb>().type = 2;
                    person.Limbs[3].gameObject.GetOrAddComponent<BetterLimb>().type = 3;
                    foreach(LimbBehaviour limb in person.Limbs)
                    {
                        limb.gameObject.GetOrAddComponent<FallLimb>();
                    }
                }
            };
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = "Android Charger" + ModTag, //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Charges up androids. Use after they run out of power, or after repairing a broken battery.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Machinery"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/chargerthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/charger.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.FixColliders();
                        Instance.AddComponent<AndroidCharger>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = "Android Consciousness module" + ModTag, //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Used in fixing androids. Give this to an android, and the respective component will be fixed.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Machinery"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/conscthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/consc.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.FixColliders();
                        Instance.GetOrAddComponent<AndroidPart>().healtype = 1;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = "Android Battery" + ModTag, //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Used in fixing androids. Give this to an android, and the respective component will be fixed.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Machinery"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/batterythumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/battery.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.FixColliders();
                        Instance.GetOrAddComponent<AndroidPart>().healtype = 2;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = "Android Root Motor" + ModTag, //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Used in fixing androids. Give this to an android, and the respective component will be fixed.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Machinery"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/rootrotorthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/rootrotor.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.FixColliders();
                        Instance.GetOrAddComponent<AndroidPart>().healtype = 3;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = "Android Power Manager" + ModTag, //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Used in fixing androids. Give this to an android, and the respective component will be fixed.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Machinery"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/powermanagerthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/powermanager.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.FixColliders();
                        Instance.GetOrAddComponent<AndroidPart>().healtype = 4;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = "Android Pain Receptors" + ModTag, //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Used in fixing androids. Give this to an android, and the respective component will be fixed.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Machinery"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/receptorthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/receptor.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.FixColliders();
                        Instance.GetOrAddComponent<AndroidPart>().healtype = 5;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = "Android Upper Rotors" + ModTag, //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Used in fixing androids. Give this to an android, and the respective component will be fixed.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Machinery"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/armrotorthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/armrotor.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.FixColliders();
                        Instance.GetOrAddComponent<AndroidPart>().healtype = 6;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
                    NameOverride = "Android Lower Rotors" + ModTag, //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Used in fixing androids. Give this to an android, and the respective component will be fixed.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Machinery"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/legrotorthumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/legrotor.png"); //get the SpriteRenderer and replace its sprite with a custom one
                        Instance.FixColliders();
                        Instance.GetOrAddComponent<AndroidPart>().healtype = 7;
                    }
                }
            );
            LimbStatusViewBehaviour.Main.gameObject.AddComponent<OrganInspect>();
        }

        public static bool Chance(float chance)
        {
            return Random.Range(0f, 1f) < chance;
        }
    }
    public class AndroidCharger : MonoBehaviour
    {
        float disstime = 2.5f;
        bool dodis;
        void Update()
        {
            if (dodis) disstime -= Time.deltaTime;
            if(disstime < 0f)
            {
                Destroy(gameObject);
                ModAPI.CreateParticleEffect("Disintegration", transform.position);
            }
        }
        void OnCollisionEnter2D(Collision2D col)
        {
            if(!dodis && col.collider.GetComponent<LimbBehaviour>() && col.collider.GetComponent<LimbBehaviour>().SpeciesIdentity == "Android" && col.collider.GetComponent<LimbBehaviour>().Person.TryGetComponent(out BetterAndroid bt))
            {
                dodis = true;
                ModAPI.CreateParticleEffect("Spark", transform.position);
                ModAPI.CreateParticleEffect("MetalHit", transform.position);
                Destroy(GetComponent<Collider2D>());
                gameObject.AddComponent<FixedJoint2D>().connectedBody = col.rigidbody;
                bt.battery = 1200f;
            }
        }
    }
    public class AndroidPart : MonoBehaviour
    {
        float disstime = 3.5f;
        bool dodis;
        public int healtype;
        BetterAndroid bt;
        void Update()
        {
            if (dodis) disstime -= Time.deltaTime;
            if (disstime < 0f)
            {
                Destroy(gameObject);
                ModAPI.CreateParticleEffect("Disintegration", transform.position);
                switch(healtype)
                {
                    case 0:
                        bt.motherboardBroken = false;
                        break;
                    case 1:
                        bt.conscBroken = false;
                        break;
                    case 2:
                        bt.batteryBroken = false;
                        break;
                    case 3:
                        bt.motorsBroken[0] = false;
                        break;
                    case 4:
                        bt.powerManagerBroken = false;
                        break;
                    case 5:
                        bt.receptorsBroken = false;
                        break;
                    case 6:
                        bt.motorsBroken[1] = false;
                        bt.motorsBroken[2] = false;
                        bt.motorsBroken[5] = false;
                        break;
                    case 7:
                        bt.motorsBroken[3] = false;
                        bt.motorsBroken[4] = false;
                        break;
                }
            }
        }
        void OnCollisionEnter2D(Collision2D col)
        {
            if (!dodis && col.collider.GetComponent<LimbBehaviour>() && col.collider.GetComponent<LimbBehaviour>().SpeciesIdentity == "Android" && col.collider.GetComponent<LimbBehaviour>().Person.GetComponent<BetterAndroid>())
            {
                dodis = true;
                ModAPI.CreateParticleEffect("Spark", transform.position);
                ModAPI.CreateParticleEffect("MetalHit", transform.position);
                Destroy(GetComponent<Collider2D>());
                gameObject.AddComponent<FixedJoint2D>().connectedBody = col.rigidbody;
                bt = col.collider.GetComponent<LimbBehaviour>().Person.GetComponent<BetterAndroid>();
            }
        }
    }
    public class OrganInspect : MonoBehaviour
    {
        float timer = -Mathf.Epsilon;
        void Update()
        {
            timer += Time.unscaledDeltaTime;
            if (timer > LimbStatusViewBehaviour.Main.UpdateInterval)
            {
                timer = 0f;
                List<PersonBehaviour> list = new List<PersonBehaviour>();
                foreach (LimbBehaviour limb in LimbStatusViewBehaviour.Main.Limbs)
                {
                    if (!list.Contains(limb.Person))
                    {
                        list.Add(limb.Person);
                        if (limb.SpeciesIdentity == "Android" && limb.Person.TryGetComponent(out BetterAndroid bt))
                        {
                            if (bt.motherboardBroken) LimbStatusViewBehaviour.Main.LimbDamageSourceStats.text += "destroyed motherboard\n";
                            if (bt.conscBroken) LimbStatusViewBehaviour.Main.LimbDamageSourceStats.text += "damaged C-module\n";
                            if (bt.batteryBroken) LimbStatusViewBehaviour.Main.LimbDamageSourceStats.text += "destroyed battery\n";
                            if (bt.motorsBroken[0]) LimbStatusViewBehaviour.Main.LimbDamageSourceStats.text += "damaged root motor\n";
                            if (bt.powerManagerBroken) LimbStatusViewBehaviour.Main.LimbDamageSourceStats.text += "damaged power manager\n";
                            if (bt.receptorsBroken) LimbStatusViewBehaviour.Main.LimbDamageSourceStats.text += "damaged receptors\n";
                            int dmgmount = 0;
                            int i = 0;
                            foreach(bool b in bt.motorsBroken)
                            {
                                if (b && i!=0) dmgmount++;
                                i++;
                            }
                            if (dmgmount > 0) LimbStatusViewBehaviour.Main.LimbDamageSourceStats.text += "damaged limb motors (" + dmgmount.ToString() + ")\n";
                        }
                    }

                }

            }
        }
    }
    [SkipSerialisation]
    public class FallLimb : MonoBehaviour
    {
        private static ContactPoint2D[] contactBuffer = new ContactPoint2D[8];
        LimbBehaviour limb;
        void Start()
        {
            limb = GetComponent<LimbBehaviour>();
        }
        private void OnCollisionEnter2D(Collision2D collision)
        {
            int contactCount = collision.GetContacts(contactBuffer);
            float impulse = Utils.GetAverageImpulse(contactBuffer, contactCount);
            impulse *= 0.3f;
            if (impulse > 1)
            {
                limb.Damage(impulse * 10f);
                limb.SkinMaterialHandler.AddDamagePoint(DamageType.Blunt, (Vector2)transform.position + Vector2.right * ModAPI.PixelSize * Random.Range(-5f, 5f) + Vector2.up * ModAPI.PixelSize * Random.Range(-5f, 5f), impulse * 0.4f);
            }
        }
        void Shot(Shot shot)
        {
            limb.Damage(shot.damage * 0.25f);
        }
    }
    [SkipSerialisation]
    public class BetterLimb : MonoBehaviour
    {
        public int type;
        BetterAndroid bt;
        void Start()
        {
            bt = GetComponent<LimbBehaviour>().Person.GetComponent<BetterAndroid>();
        }
        void Repair()
        {
            switch(type)
            {
                case 0:
                    bt.conscBroken = false;
                    break;
                case 1:
                    bt.powerManagerBroken = false;
                    bt.motorsBroken[1] = false;
                    bt.motorsBroken[2] = false;
                    bt.motorsBroken[5] = false;
                    break;
                case 2:
                    bt.batteryBroken = false;
                    bt.motorsBroken[0] = false;
                    break;
                case 3:
                    bt.receptorsBroken = false;
                    bt.motorsBroken[3] = false;
                    bt.motorsBroken[4] = false;
                    break;
            }
        }
        void Shot(Shot shot)
        {
            switch (type)
            {
                case 0:
                    if (Mod.Chance(0.000043f * shot.damage))
                    {
                        bt.TryBreakComponent(0);
                    }
                    if (Mod.Chance(0.00055f * shot.damage))
                    {
                        bt.TryBreakComponent(1);
                    }
                    break;
                case 1:
                    if (Mod.Chance(0.00045f * shot.damage))
                    {
                        bt.TryBreakComponent(4);
                    }
                    if (Mod.Chance(0.0004f * shot.damage))
                    {
                        bt.TryBreakComponent(6);
                    }
                    if (Mod.Chance(0.0004f * shot.damage))
                    {
                        bt.TryBreakComponent(7);
                    }
                    if (Mod.Chance(0.0003f * shot.damage))
                    {
                        bt.TryBreakComponent(10);
                    }
                    break;
                case 2:
                    if (Mod.Chance(0.00033f * shot.damage))
                    {
                        bt.TryBreakComponent(2);
                    }
                    if (Mod.Chance(0.0004f * shot.damage))
                    {
                        bt.TryBreakComponent(3);
                    }
                    break;
                case 3:
                    if (Mod.Chance(0.00055f * shot.damage))
                    {
                        bt.TryBreakComponent(5);
                    }
                    if (Mod.Chance(0.0005f * shot.damage))
                    {
                        bt.TryBreakComponent(8);
                    }
                    if (Mod.Chance(0.0005f * shot.damage))
                    {
                        bt.TryBreakComponent(9);
                    }
                    break;
            }
        }
    }
    public class BetterAndroid : MonoBehaviour
    {
        public List<bool> motorsBroken = new List<bool>(new bool[6]); //0 is the global motor, 1 is spine, 2 is front arm, 3 is back arm, 4 is front leg, 5 is back leg
        public bool motherboardBroken; //will cause the entire android to shut down. unrepairable
        public bool receptorsBroken; //will completebly disable all shock and pain, causes the stumble animation every second
        public bool batteryBroken; //will cause the charge to be permamently 0
        public bool powerManagerBroken; //random bouts of ouch ouch electricity, will drain the power quickly
        public bool conscBroken; //causes random passing out
        public float battery = 1200f;
        float updateTime;
        PersonBehaviour person;
        void Start()
        {
            person = GetComponent<PersonBehaviour>();
        }
        void Update()
        {
            battery -= Time.deltaTime;
            updateTime -= Time.deltaTime;
            if (updateTime < 0f)
            {
                updateTime = 1f;
                if (motherboardBroken)
                {
                    person.Consciousness = 0f;
                }
                if (conscBroken && Mod.Chance(0.01f))
                {
                    person.Consciousness -= 0.25f;
                }
                if (batteryBroken)
                {
                    battery = 0f;
                }
                if (receptorsBroken)
                {
                    person.PainLevel = 0f;
                    person.ShockLevel = 0f;
                    person.Wince(80f);
                }
                if (battery <= 0f)
                {
                    foreach(LimbBehaviour limb in person.Limbs)
                    {
                        limb.Numbness = 1000f;
                    }
                }
                if(motorsBroken[0])
                {
                    foreach (LimbBehaviour limb in person.Limbs)
                    {
                        limb.Numbness = 60f;
                    }
                }
                if (motorsBroken[1])
                {
                    person.Limbs[10].Numbness = 1000f;
                    person.Limbs[11].Numbness = 1000f;
                }
                if (motorsBroken[2])
                {
                    person.Limbs[12].Numbness = 1000f;
                    person.Limbs[13].Numbness = 1000f;
                }
                if (motorsBroken[3])
                {
                    person.Limbs[4].Numbness = 1000f;
                    person.Limbs[5].Numbness = 1000f;
                    person.Limbs[6].Numbness = 1000f;
                }
                if (motorsBroken[4])
                {
                    person.Limbs[7].Numbness = 1000f;
                    person.Limbs[8].Numbness = 1000f;
                    person.Limbs[9].Numbness = 1000f;
                }
                if (motorsBroken[5])
                {
                    person.Limbs[0].Numbness = 1000f;
                    person.Limbs[1].Numbness = 1000f;
                    person.Limbs[2].Numbness = 1000f;
                    person.Limbs[3].Numbness = 1000f;
                }
                if (powerManagerBroken && Mod.Chance(0.01f))
                {
                    foreach (LimbBehaviour limb in person.Limbs)
                    {
                        limb.PhysicalBehaviour.charge += 200f;
                    }
                    battery -= 500f;
                }
                if(person.Limbs[2].InternalTemperature > 100f)
                {
                    TryBreakComponent(Random.Range(0, 11));
                }
            }
        }
        void FixedUpdate()
        {
            foreach (LimbBehaviour limb in person.Limbs)
            {
                limb.CirculationBehaviour.HealBleeding();
            }
            person.AdrenalineLevel = 0f;
        }
        public void TryBreakComponent(int type)
        {
            switch (type)
            {
                case 0:
                    if (!motherboardBroken)
                    {
                        motherboardBroken = true;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[0].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[0].transform.position);
                    }
                    break;
                case 1:
                    if (!conscBroken)
                    {
                        conscBroken = true;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[0].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[0].transform.position);
                    }
                    break;
                case 2:
                    if (!batteryBroken)
                    {
                        batteryBroken = true;
                        battery = 0f;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[2].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        ModAPI.CreateParticleEffect("Explosion", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[2].transform.position);
                    }
                    break;
                case 3:
                    if (!motorsBroken[0])
                    {
                        motorsBroken[0] = true;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[2].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[2].transform.position);
                    }
                    break;
                case 4:
                    if (!powerManagerBroken)
                    {
                        powerManagerBroken = true;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[2].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[1].transform.position);
                    }
                    break;
                case 5:
                    if (!receptorsBroken)
                    {
                        receptorsBroken = true;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[2].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[3].transform.position);
                    }
                    break;
                case 6:
                    if (!motorsBroken[1])
                    {
                        motorsBroken[1] = true;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[2].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[1].transform.position);
                    }
                    break;
                case 7:
                    if (!motorsBroken[2])
                    {
                        motorsBroken[2] = true;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[2].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[1].transform.position);
                    }
                    break;
                case 8:
                    if (!motorsBroken[3])
                    {
                        motorsBroken[3] = true;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[2].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[3].transform.position);
                    }
                    break;
                case 9:
                    if (!motorsBroken[4])
                    {
                        motorsBroken[4] = true;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[2].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[3].transform.position);
                    }
                    break;
                case 10:
                    if (!motorsBroken[5])
                    {
                        motorsBroken[5] = true;
                        ModAPI.CreateParticleEffect("BrokenElectronicsSpark", person.Limbs[2].transform.position);
                        ModAPI.CreateParticleEffect("BigZap", person.Limbs[2].transform.position);
                        GenerateBrokenPart(person.Limbs[1].transform.position);
                    }
                    break;
            }
        }
        public static void GenerateBrokenPart(Vector2 pos)
        {
            //print("Generating broken part at: " + pos.ToString());
            Sprite spr = Mod.brokenparts.PickRandom();
            GameObject g = ModAPI.CreatePhysicalObject("BrokenComponent", spr);
            //print("1");
            g.layer = 10;
            //print("2");
            g.transform.position = pos;
            //print("3");
            g.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
            //print("4");
            g.GetComponent<Rigidbody2D>().velocity = new Vector2(Random.Range(-5f, 5f), Random.Range(0, 5f));
            //print("5");
            g.GetComponent<Rigidbody2D>().angularVelocity = Random.Range(-60, 60f);
            //print("6");
            Destroy(g, 5f);
            //print("7");
        }
    }

}